 Member
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

 Map
   !Local Procedures, if any, go here
   subclassproc(unsigned,unsigned,UNSIGNED,long),long,pascal   
   WaitProc(long),long,pascal
   !API Prototypes
   Module('api')
     createthread(long,long,long,long,long,*long),raw,unsigned,pascal,name('createthread')
     waitforsingleobject(unsigned,long),raw,long,pascal,name('waitforsingleobject'),proc
     WaitForMultipleObjects(long,long,long,long),raw,long,pascal,proc
     FindFirstChangeNotification(*cstring, bool,long),raw,unsigned,pascal,name('FindFirstChangeNotificationA')
     FindNextChangeNotification(unsigned),raw,bool,pascal,name('FindNextChangeNotification'),proc
     FindCloseChangeNotification(unsigned),raw,bool,pascal,name('FindCloseChangeNotification'),proc
     TerminateThread(unsigned,long),raw,bool,pascal,proc
     RegisterWindowMessage(*cstring lpString),raw,long,pascal,name('RegisterWindowMessageA')
     SendMessage(UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL, NAME('SendMessageA'),proc
     PostMessage(UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL, NAME('PostMessageA'),proc
     CallWindowProc(long,unsigned,UNSIGNED,unsigned,Long),raw,Long,PASCAL,NAME('CallWindowProcA')
     memcpy(long,long,long),raw,long,name('_memcpy'),proc
     closehandle(unsigned),raw,bool,pascal,proc
     getlasterror(),ulong,pascal
     CreateEvent(long,long,long,long),unsigned,raw,pascal,proc,name('createeventa')
     setevent(unsigned),bool,raw,pascal,proc
     isWindow(unsigned),bool,pascal
   End
 end

!Includes this class and others
 include('cnotifCl.inc')

!global data for this module
Invalid_handle_Value equate(-1)
Return:Benign equate(0)
Return:Fatal  equate(3)
Return:Notify equate(5)
stopHwndQ byte(0)
glo:hwndQ Queue
hwnd      unsigned
wmsg      long
cwevent   long
cwthread  long
savedproc long
  end

subclassproc  Procedure(unsigned hwnd,unsigned wmsg,UNSIGNED wparam,long lparam)
savegrp like(glo:hwndQ)
  code
  !get the info if any from hwndQ
  If stophwndq then return(1).
  glo:hwndq.hwnd=hwnd
  get(glo:hwndQ,glo:hwndQ.hwnd)
  If errorcode() then return(1).
  savegrp = glo:hwndQ

  !if this is the message we are waiting for then post()
  if savegrp.wmsg=wmsg then
    Post(SaveGrp.CWEvent,,SaveGrp.CWThread)
  end
  return callwindowproc(savegrp.savedproc,hwnd,wmsg,wparam,lparam)

waitproc procedure(long lpwaitstruct)
loc:WaitStruct like(WaitStructGroupType)
infinite       equate(-1)
Wait_object_0  equate(0)
  code
  memcpy(address(loc:waitstruct),lpwaitstruct,size(WaitStructGroupType))
  loop
    !if waitstruct.notifhandle has becomes signaled then send a message
    if waitForMultipleObjects(2,address(loc:WaitStruct.notifhandle),0,infinite)=Wait_object_0  then
      Sendmessage(loc:waitstruct.hwnd,loc:waitstruct.wmsg,0,0)
      if loc:waitstruct.autoreset then
        FindNextchangeNotification(loc:waitstruct.notifhandle)
        cycle
      end
    end
    break
  end !sleep again if reset
  return 0

!-------------------------------------------------------------
!---Start of cnotifcl
!-------------------------------------------------------------
!Event:FileChanged,cTarget,File_Notify_Change_fILE_NAME
cnotifClType.Init                  Procedure(long pCWThread, long pCWEvent, *cstring pTargetdir, long pNotifType, long pWatchSubtree=0,long pautoreset)
savedproc  long,auto
threadid   long,auto
  Code
  Clear(SELF)

  !subclass the current window to receive notifications
  SELF.WaitStruct.wMsg = RegisterWindowMessage(pTargetdir)
  settarget(,pCWthread)
  SELF.WaitStruct.hwnd=0{prop:handle}
  SELF.WaitStruct.AutoReset = pAutoReset
  savedproc=0{prop:wndproc}
  StopHwndQ=true
  glo:hwndQ.hwnd=SELF.waitstruct.hwnd
  glo:hwndq.wmsg=SELF.waitstruct.wMsg
  glo:hwndq.CWEvent=pCWEvent
  glo:hwndQ.CWThread=pCWthread
  glo:hwndQ.savedProc=savedproc
  Add(glo:hwndQ,glo:hwndQ.hwnd)
  stophwndq=false
  0{prop:wndproc}=address(subclassproc)
  settarget()

  !create an event object that will tell the alt thread the app is closing
  SELF.WaitStruct.hEvent = createevent(0,1,0,0)
  if ~SELF.WaitStruct.hEvent then
    SELF.kill()
    return return:fatal
  end

  !intiate change notification
  SELF.waitstruct.NotifHandle=findFirstchangeNotification(pTargetDir,pWatchSubTree,pnotifType)
  If SELF.waitstruct.NotifHandle=Invalid_handle_value then
    SELF.Kill()
    return return:fatal
  end

  !create a thread to listen
  SELF.Threadhandle=createthread(0,256,address(waitproc), address(SELF.waitstruct),1,threadid)
  If ~SELF.ThreadHandle then
    SELF.Kill()
    return Return:Fatal
  end
  Return Return:benign

cnotifcltype.resetNotif             Procedure()
threadid long,auto
  code
  If SELF.ThreadHandle then
    Closehandle(SELF.ThreadHandle)
    clear(SELF.ThreadHandle)
  end
  If SELF.WaitStruct.NotifHandle then
    FindNextchangeNotification(SELF.WaitStruct.Notifhandle)
    SELF.Threadhandle=createthread(0,256,address(waitproc), address(SELF.waitstruct),0,threadid)
  end
  Return

cnotifClType.Kill              Procedure()
!destroy any dynamic objects and clean up
    Code

    !reverse the subclass
    if SELF.WaitStruct.hwnd then
      StopHwndQ=true
      glo:hwndQ.hwnd=SELF.WaitStruct.hwnd
      get(Glo:hwndq, glo:hwndq.hwnd)
      if ~errorcode() then
        0{prop:wndproc}=glo:hwndq.savedproc
        delete(glo:hwndQ)
      end
      StopHwndQ=false
      clear(SELF.WaitStruct.hwnd)
    end

    !kill the alt thread
    If SELF.Threadhandle and SELF.WaitStruct.hEvent then
      SetEvent(SELF.WaitStruct.hevent)
      closehandle(SELF.ThreadHandle)
      closehandle(SELF.waitstruct.hevent)
      clear(SELF.Threadhandle)
      clear(SELF.WaitStruct.hEvent)
    end

    !Close the notificaiton process
    If SELF.WaitStruct.NotifHandle then
      FindCloseChangeNotification(SELF.WaitStruct.NotifHandle)
      clear(SELF.WaitStruct.Notifhandle)
    end


    RETURN

